(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__treeUtils__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__validate__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__filters__ = __webpack_require__(3);




/* harmony default export */ __webpack_exports__["default"] = ({
  TreeUtils: __WEBPACK_IMPORTED_MODULE_0__treeUtils__["a" /* default */],
  Validate: __WEBPACK_IMPORTED_MODULE_1__validate__["a" /* default */],
  Filters: __WEBPACK_IMPORTED_MODULE_2__filters__["a" /* default */]
});

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
function toTree(list, parent, id, pid) {
  const children = list.filter(item => {
    return item[pid] === parent[id];
  });
  if (children.length !== 0) {
    parent.children = children;
    children.forEach(item => {
      toTree(list, item, id, pid);
    });
  }
}

function getParent(list, id, pid) {
  return list.filter(item => {
    return list.every(obj => {
      return item[pid] !== obj[id];
    });
  });
}

function list2tree(list, id = 'id', pid = 'parentId') {
  list = JSON.parse(JSON.stringify(list));
  const topList = getParent(list, id, pid);
  topList.forEach(item => toTree(list, item, id, pid));
  return topList;
}

function findChildren(pid, list) {
  const tree = findTreeNode(pid, list2tree(list));
  if (tree) {
    return tree.children;
  } else {
    return [];
  }
}

function findTreeNode(treeId, treeList) {
  for (let i = 0; i < treeList.length; i++) {
    if (treeList[i].id === treeId) {
      return treeList[i];
    } else {
      if(treeList[i].children&&treeList[i].children.length>0){
        const treeNode = findTreeNode(treeId, treeList[i].children);
        if(treeNode){
          return treeNode;
        }
      }
    }
  }
  return null;
}


/* harmony default export */ __webpack_exports__["a"] = ({
  list2tree,
  findChildren
});

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export isPhone */
/* unused harmony export isWscnEmail */
/* unused harmony export validateURL */
/* unused harmony export validateLowerCase */
/* unused harmony export validateUpperCase */
/* unused harmony export validatAlphabets */
/* unused harmony export validatNumber */
/* unused harmony export validatInteger */
/* unused harmony export validatDecimal */
/**
 * Created by jiachenpan on 16/11/18.
 */

/* 是否是手机号*/
function isPhone(str) {
  const reg = /^1[3|4|5|8][0-9]\d{8}$/;
  return reg.test(str);
}

/* 是否是公司邮箱*/
function isWscnEmail(str) {
  const reg = /^[a-z0-9](?:[-_.+]?[a-z0-9]+)*@wallstreetcn\.com$/i;
  return reg.test(str.trim());
}

/* 合法uri*/
function validateURL(textval) {
  const urlregex = /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/;
  return urlregex.test(textval);
}

/* 小写字母*/
function validateLowerCase(str) {
  const reg = /^[a-z]+$/;
  return reg.test(str);
}

/* 大写字母*/
function validateUpperCase(str) {
  const reg = /^[A-Z]+$/;
  return reg.test(str);
}

/* 大小写字母*/
function validatAlphabets(str) {
  const reg = /^[A-Za-z]+$/;
  return reg.test(str);
}

/* 数字 */
function validatNumber(str) {
  const reg = /^[\d]+\.?[\d]+$/;
  return reg.test(str);
}

/* 整数 */
function validatInteger(str) {
  const reg = /^[\d]+$/;
  return reg.test(str);
}

/* 小数 */
function validatDecimal(str) {
  const reg = /^[\d]+\.[\d]+$/;
  return reg.test(str);
}


/* harmony default export */ __webpack_exports__["a"] = ({
  validatDecimal,
  validatInteger,
  validatNumber,
  validatAlphabets,
  validateUpperCase,
  validateLowerCase,
  validateURL,
  isWscnEmail,
  isPhone
});

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/**
 * Created by Administrator on 2017/8/18.
 */

//过滤手机号
function toTel (value) {
  let start = value.slice(0,4),
    end = value.slice(-2);
  return `${start}******${end}`
}

//小写转大写
function uppercase (value) {
  return (value || value === 0)
    ? value.toString().toUpperCase()
    : ''
}

//大写转小写
function lowercase (value) {
  return (value || value === 0)
    ? value.toString().toLowerCase()
    : ''
}

/**
 * 数字转换为货币
 * @param value
 * @param currency : 使用不同的符号 例: currency(£) // 12345 => £12,345.00
 * @param decimals : 使用不同的小数位数 例: currency(' ₽ ',0) // 12345 => ₽12,345
 */
function currency  (value, currency, decimals) {
  var digitsRE = /(\d{3})(?=\d)/g;
  value = parseFloat(value)
  if (!isFinite(value) || (!value && value !== 0)) return '';
  currency = currency != null ? currency : '$';
  decimals = decimals != null ? decimals : 2;
  var stringified = Math.abs(value).toFixed(decimals);
  var _int = decimals
    ? stringified.slice(0, -1 - decimals)
    : stringified;
  var i = _int.length % 3;
  var head = i > 0
    ? (_int.slice(0, i) + (_int.length > 3 ? ',' : ''))
    : '';
  var _float = decimals
    ? stringified.slice(-1 - decimals)
    : '';
  var sign = value < 0 ? '-' : '';
  return sign + currency + head +
    _int.slice(i).replace(digitsRE, '$1,') +
    _float
}


/* harmony default export */ __webpack_exports__["a"] = ({
  currency,
  lowercase,
  uppercase,
  toTel
});

/***/ })
/******/ ]);
});